// XDisplay Engine
var XDisplay_Engine = { 

    objects: new Array,
    resources: new Array,
    animations: new Array,
    
    fps: 30,
    frame: 1,
    displaying: false, 
    context: null,
    width: 0,
    height: 0,
    
    setContext: function(context) {
      this.context = context;
    },
    
    setDimensions: function(width, height) {
      this.width = width;
      this.height = height;
    },

    addObject: function(object) {
        this.objects.push(object); 
    },
    
    addContainer: function(name) {
        this.objects[name] = new Array; 
    },
    
    addObjectToContainer: function(name, object) {
        this.objects[name].push(object); 
    },
    
    removeObject: function(name) { 

      var tmp = new Array();
      var s = this.objects.length;
      for(var i in this.objects)
      {
        if(this.objects[i] instanceof Array)
        {
          tmp[i] = new Array();
          var s = this.objects[i].length;
          for(var j=0; j<s; j++)
          {
            if(this.objects[i][j].name != name)
              tmp[i].push(this.objects[i][j]);
          }
        }
        else if(this.objects[i].name != name)
          tmp.push(this.objects[i]);
      } 
      
      this.objects = tmp;

    },
    
    removeObjectFromContainer: function(name, name_obj) {
      if(this.objects[name])
      {
        var tmp = new Array();
        var s = this.objects[name].length;
        for(var i=0; i<s; i++)
        {
          if(this.objects[name][i].name != name_obj)
            tmp.push(this.objects[name][i]);
        } 
        
        this.objects[name] = tmp;
      }
    },
    
    //supprime le container
    removeContainer: function(name) {
      var tmp = new Array();
      for(var i in this.objects)
      {
        //alert(i+' '+name);
        if(i != name)
          tmp.push(this.objects[i]);
      } 
      
      this.objects = tmp;    
    },
    
    //vide le container
    clearContainer: function(name) {
      this.objects[name] = new Array();    
    },
    
    getObjects: function() {
      
      return this.objects;
      
    },
    
    getObjectsContainer: function(name) {
      
      if(this.objects[name])
        return this.objects[name];
      else
        return new Array;
      
    },
    
    getObject: function(name) {
    
      for(var i in this.objects)
      {
        if(this.objects[i] instanceof Array)
        {
          var s = this.objects[i].length;
          for(var j=0; j<s; j++)
          {
            if(this.objects[i][j].name == name)
             return this.objects[i][j]; 
          }
        }
        else if(this.objects[i].name == name)
          return this.objects[i];
      }
      
      return null;
    
    },
    
    removeAllObjects: function() {
      this.objects = new Array();
    },
    
    display: function() {
              
       this.cleanDisplay();
       for(var i in this.objects)
       {
         if(this.objects[i] instanceof Array)
         {
          var s = this.objects[i].length;
          for(var j=0; j<s; j++)
          {
            if(this.objects[i][j] != undefined && this.objects[i][j].draw)
            {
              this.objects[i][j].draw(this.context, this.frame/this.fps);
            }
          }
         }
         else if(this.objects[i].draw)
          this.objects[i].draw(this.context, this.frame/this.fps);
       }
       this.frame++;
       if(this.frame > this.fps)
        this.frame = 0;
    
    },
    
    cleanDisplay: function() {
      this.context.fillStyle = "rgb(255, 255, 255)";
      this.context.fillRect(0, 0, this.width, this.height);
    },
    
    showAnimation: function(x, y, img, scale) {
      
    }

}

function cloneObject(what,rec) {
    for (var i in what) {
       if ((rec) && (typeof what[i]=="object"))
           this[i] = new cloneObject(what[i],true);
       else
           this[i] = what[i];
    }
}

function destroyObject(obj) {
  for(var e in obj)
    obj[e] = null;
}
