// XPhysics Engine
var XPhysics_Engine = {

    width: 0,
    height: 0,
    objects: new Array(),
    
    setDisplayDimensions: function(width, height) {
      this.width = width;
      this.height = height;
    },
    
    /* Fonction de base */
    addObject: function(object) {

       this.objects.push(object); 
    },
    
    addContainer: function(name) {
        this.objects[name] = new Array; 
    },
    
    addObjectToContainer: function(name, object) {
        this.objects[name].push(object); 
    },
    
    removeObject: function(name) { 

      var tmp = new Array();
      var s = this.objects.length;
      for(var i in this.objects)
      {
        if(this.objects[i] instanceof Array)
        {
          tmp[i] = new Array();
          var s = this.objects[i].length;
          for(var j=0; j<s; j++)
          {
            if(this.objects[i][j].name != name)
              tmp[i].push(this.objects[i][j]);
          }
        }
        else if(this.objects[i].name != name)
          tmp.push(this.objects[i]);
      } 
      
      this.objects = tmp;

    },
    
    removeObjectFromContainer: function(name, name_obj) {
      if(this.objects[name])
      {
        var tmp = new Array();
        var s = this.objects[name].length;
        for(var i=0; i<s; i++)
        {
          if(this.objects[name][i].name != name_obj)
            tmp.push(this.objects[name][i]);
        } 
        
        this.objects[name] = tmp;
      }
    },
    
    //supprime le container
    removeContainer: function(name) {
      var tmp = new Array();
      for(var i in this.objects)
      {
        if(i != name)
          tmp.push(this.objects[i]);
      } 
      
      this.objects = tmp;    
    },
    
    //vide le container
    clearContainer: function(name) {
      this.objects[name] = new Array();    
    },
    
    getObjects: function() {
      
      return this.objects;
      
    },
    
    getObject: function(name) {
    
      var s = this.objects.length;
      for(var i=0; i<s; i++)
      {
        if(this.objects[i].name == name)
          return this.objects[i];
      }
      
      return null;
    
    },
    
    removeAllObjects: function() {
      this.objects = new Array();
    },
      
    /* 
     * Test si object est en collision avec un objects (Array)
     * Si clean est dfini  true les objects en dehors n'apparaissant plus  l'cran sont supprim
     *     
     */     
    check_collision:  function(object, clean)
    {
        /* Collision de object avec 1 objects ? */
        var collisions = new Array();
        var s = this.objects.length;
        for(var i in this.objects)
        {
          if(this.objects[i] instanceof Array)
          {
            var s = this.objects[i].length;
            for(var j=0; j<s; j++)
            {
              if(object != this.objects[i][j])
              {
                //collision rectangle/rectangle
                if(object.hitbox_type == 'rect' && this.objects[i][j].hitbox_type == 'rect')
                {
                  if(this.hit_rect(object.x, object.y, object.width_hit, object.height_hit, this.objects[i][j].x, this.objects[i][j].y, this.objects[i][j].width_hit, this.objects[i][j].height_hit))
                  {
                    collisions.push(this.objects[i][j].name);
                  }
                }
                //collision cercle/cercle
                else if(object.hitbox_type == 'circle' && this.objects[i][j].hitbox_type == 'circle')
                {
                  if(this.hit_circle(object.x, object.y, object.width_hit, this.objects[i][j].x, this.objects[i][j].y, this.objects[i][j].width_hit))
                  {
                    collisions.push(this.objects[i][j].name);
                  }
                }
                //collision cercle/rectangle
                else if(object.hitbox_type == 'circle' && this.objects[i][j].hitbox_type == 'rect')
                {
                  if(this.hit_rect_circle(this.objects[i][j].x, this.objects[i][j].y, this.objects[i][j].width_hit, this.objects[i][j].height_hit, object.x, object.y, object.width_hit, object.height_hit))
                    collisions.push(this.objects[i][j].name);
                }
                //collision rectangle/cercle
                else if(object.hitbox_type == 'rect' && this.objects[i][j].hitbox_type == 'circle')
                {
                  if(this.hit_rect_circle(object.x, object.y, object.width_hit, object.height_hit, this.objects[i][j].x, this.objects[i][j].y, this.objects[i][j].width_hit, this.objects[i][j].height_hit))
                    collisions.push(this.objects[i][j].name);
                }
                
                if(clean)
                {
                  //supprime l'object si en dehors du canvas
                  if(this.objects[i][j].x+this.objects[i][j].width <= 0 || this.objects[i][j].x >= this.width || this.objects[i][j].y+this.objects[i][j].height <= 0 || this.objects[i][j].y >= this.height)
                  {
                    xde.removeObject(this.objects[i][j].name);
                    this.removeObject(this.objects[i][j].name);                  
                    s--;
                  }
                }
              }
            }
          }
          else
          {
            if(object != this.objects[i])
            {
              //collision rectangle/rectangle
              if(object.hitbox_type == 'rect' && this.objects[i].hitbox_type == 'rect')
              {
                if(this.hit_rect(object.x, object.y, object.width_hit, object.height_hit, this.objects[i].x, this.objects[i].y, this.objects[i].width_hit, this.objects[i].height_hit))
                {
                  collisions.push(this.objects[i].name);
                }
              }
              //collision circle/circle
              else if(object.hitbox_type == 'circle' && this.objects[i].hitbox_type == 'circle')
              {
                if(this.hit_circle(object.x, object.y, object.width_hit, this.objects[i].x, this.objects[i].y, this.objects[i].width_hit))
                {
                  collisions.push(this.objects[i].name);
                }
              }
              //collision cercle/rectangle
              else if(object.hitbox_type == 'circle' && this.objects[i].hitbox_type == 'rect')
              {
                if(this.hit_rect_circle(this.objects[i].x, this.objects[i].y, this.objects[i].width_hit, this.objects[i].height_hit, object.x, object.y, object.width_hit, object.height_hit))
                  collisions.push(this.objects[i].name);
              }
              //collision rectangle/cercle
              else if(object.hitbox_type == 'rect' && this.objects[i].hitbox_type == 'circle')
              {
                if(this.hit_rect_circle(object.x, object.y, object.width_hit, object.height_hit, this.objects[i].x, this.objects[i].y, this.objects[i].width_hit, this.objects[i].height_hit))
                  collisions.push(this.objects[i].name);
              }
              
              if(clean)
              {
                //supprime l'object si en dehors du canvas
                if(this.objects[i].x+this.objects[i].width <= 0 || this.objects[i].x >= this.width || this.objects[i].y+this.objects[i].height <= 0 || this.objects[i].y >= this.height)
                {
                  xde.removeObject(this.objects[i].name);
                  this.removeObject(this.objects[i].name);                  
                  s--;
                }
              }
            }
          }
        }
        
        return collisions;
    },
      
    /* Collison entre 2 rectangle ? */
    hit_rect: function(x1, y1, w1, h1, x2, y2, w2, h2) {
      
        return x1+w1 >= x2 && x1 <= x2+w2 && y1+h1 >= y2 && y1 <= y2+h2;
        
    },
    /* Collison entre 2 cercles ? */
    hit_circle: function(x1, y1, r1, x2, y2, r2) {
      distance_squared = ((x1 - x2) * (x1 - x2)) + ((y1 - y2) * (y1 - y2));
      radii_squared = (r1/2 + r2/2) * (r1/2 + r2/2);
      return distance_squared < radii_squared;
    },
    /* Collison d'un point dans un cercle ? */
    hit_point_circle: function(x1, y1, x2, y2, r2) {
      var d2 = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2);
      return d2<=r2*r2;
    },
    /* Pour collision cercle/rectangle */
    projectionSurSegment: function(cx, cy, x1, y1, w1, h1)
    {
       return (cx<x1+w1 && cx+w1 >x1 && cy<y1+h1 && cy>y1)
    },
    /* Collison entre 1 rectangle et 1 cercle ? */
    hit_rect_circle: function(x1, y1, w1, h1, x2, y2, r2) {
      if (!this.hit_rect(x1, y1, w1, h1, x2, y2, x2+r2, y2+r2))
        return false;   // premier test
      if (this.hit_point_circle(x1, y1, x2, y2, r2) || this.hit_point_circle(x1, y1+h1, x2, y2, r2) || this.hit_point_circle(x1+w1, y1, x2, y2, r2) || this.hit_point_circle(x1+w1, y1+h1, x2, y2, r2))
        return true;   // deuxieme test
      if (this.hit_rect(x2, y2, 0, 0, x1, y1, w1, h1))
        return true;   // troisieme test
      return this.projectionSurSegment(x2,y2,x1,y1,w1,h1);
      //return false;  // cas B 
    },
    
    /* Supprime l'lment d'indice e du tableau tab */
    remove_element: function(e, tab)
    {
        var size = tab.length, tmp_tab = new Array;
        
        for(var i=0; i<size; i++)
        {
          if(i != e)
          tmp_tab.push(tab[i]);
        }
        
        return tmp_tab;
    }
}